package dev.shadowsoffire.apotheosis.adventure.commands;

import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.network.chat.Component;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import com.mojang.brigadier.context.CommandContext;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.commands.Commands;
import net.minecraft.commands.CommandSourceStack;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;

public class CategoryCheckCommand
{
    public static void register(final LiteralArgumentBuilder<CommandSourceStack> root) {
        root.then(((LiteralArgumentBuilder)Commands.m_82127_("loot_category").requires(c -> c.m_6761_(2))).executes(c -> {
            final Player p = (Player)((CommandSourceStack)c.getSource()).m_81375_();
            final ItemStack stack = p.m_21205_();
            final LootCategory cat = LootCategory.forItem(stack);
            final EquipmentSlot[] slots = (EquipmentSlot[])((cat == null) ? null : cat.getSlots());
            p.m_213846_((Component)Component.m_237113_("Loot Category - " + ((cat == null) ? "null" : cat.getName())));
            p.m_213846_((Component)Component.m_237113_("Equipment Slot - " + ((slots == null) ? "null" : toStr(slots))));
            return 0;
        }));
    }
    
    static String toStr(final EquipmentSlot[] slots) {
        final StringBuilder b = new StringBuilder();
        b.append('{');
        for (int i = 0; i < slots.length; ++i) {
            b.append(slots[i].name().toLowerCase());
            if (i == slots.length - 1) {
                b.append('}');
            }
            else {
                b.append(", ");
            }
        }
        return b.toString();
    }
}
